#include "script_trigger.h"


ScriptTrigger::ScriptTrigger()
{
 scriptCalled = false;
 callScript = false;
 triggered = false;
}

ScriptTrigger::~ScriptTrigger()
{

}

void ScriptTrigger::loadParams(const TiXmlElement* root)
{
   /*{ LoadParam(root, "file", this, ScriptTrigger, setScript)
        .describe("the fileName of the script, that should be triggered by this script trigger")
        .defaultValues("");
    LoadParam(root, "function", this, ScriptTrigger, setFunction)
        .describe("the function of the script, that should be triggered by this script trigger")
        .defaultValues("");
    LoadParam(root, "abs-coor", this, ScriptTrigger, setAbsCoord)
        .describe("where this script trigger should be located")
        .defaultValues("");
    LoadParam(root, "radius", this, ScriptTrigger, setRadius)
        .describe("the fileName of the script, that should be triggered by this script trigger")
        .defaultValues(0);
    LoadParam(root, "delay", this, ScriptTrigger, setDelay)
        .describe("the delay after which the funtion sould be triggered")
        .defaultValues(0);
    LoadParam(root, "worldentity", this, ScriptTrigger, setTargetName)
        .describe("The name of the target as it is in the *.oxw file")
        .defaultValues("");
    LoadParam(root, "worldentityisparent", this, ScriptTrigger, setIsParent)
        .describe("The name of the target as it is in the *.oxw file")
        .defaultValues("");

    }*/
 timer = delay;
}



void ScriptTrigger::tick(float timestep)
{

 if((this->getAbsDirV()-target->getAbsDirV()).len() < radius)
 {
  if(!callOnce)
   {
    executeAction();
   }
  else if(callOnce && !scriptCalled)
  {
   executeAction();
   scriptCalled = true;
  }
 }

}



void ScriptTrigger::executeAction()
{
     ScriptManager* scriptManager = ScriptManager::getInstance();
     Script* script = scriptManager->getScriptByFile(this->scriptFile);
     if(!(script->selectFunction(this->functionName,0)) )
       printf("Error ScriptTrigger: Selection of %s in %s failed.\n",functionName.c_str(), scriptFile.c_str());
     if( !(script->executeFunction()) )
       printf("Error ScriptTrigger: Execution of %s in %s failed.\n",functionName.c_str(),scriptFile.c_str());
}
